std::multiset(3)

NAME
std::multiset -

SYNOPSIS

Detailed Description

  template<class _Key, class _Compare, class _Alloc> class std::multiset< _Key, _Compare, _Alloc >
Meets the requirements of a container, a reversible container, and an associative container (using equivalent keys). For a multiset<Key> the key_type and value_type are Key.

Multisets support bidirectional iterators.

Definition at line 105 of file stl_multiset.h.
std::pair< const_iterator, const_iterator > equal_range (const key_type &__x) const
std::pair< iterator, iterator > equal_range (const key_type &__x)
template<class _K1, class _C1, class _A1> bool operator< (const multiset< _K1, _C1, _A1 > &, const multiset< _K1, _C1, _A1 > &)
template<class _K1, class _C1, class _A1> bool operator== (const multiset< _K1, _C1, _A1 > &, const multiset< _K1, _C1, _A1 > &)

  Public Types
typedef _Alloc allocator_type
typedef _Rep_type::const_iterator const_iterator
typedef _Key_alloc_type::const_pointer const_pointer
typedef _Key_alloc_type::const_reference const_reference
typedef _Rep_type::const_reverse_iterator const_reverse_iterator
typedef _Rep_type::difference_type difference_type
typedef _Rep_type::const_iterator iterator
typedef _Compare key_compare
typedef _Key key_type
typedef _Key_alloc_type::pointer pointer
typedef _Key_alloc_type::reference reference
typedef _Rep_type::const_reverse_iterator reverse_iterator
typedef _Rep_type::size_type size_type
typedef _Compare value_compare
typedef _Key value_type

  Public Member Functions
iterator begin () const
void clear ()
size_type count (const key_type &__x) const
bool empty () const
iterator end () const
void erase (iterator __first, iterator __last)
size_type erase (const key_type &__x)
void erase (iterator __position)
allocator_type get_allocator () const
template<class _InputIterator> void insert (_InputIterator __first, _InputIterator __last)
iterator insert (iterator __position, const value_type &__x)
iterator insert (const value_type &__x)
key_compare key_comp () const
size_type max_size () const
multiset (const multiset< _Key, _Compare, _Alloc > &__x)
template<class _InputIterator> multiset (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
template<class _InputIterator> multiset (_InputIterator __first, _InputIterator __last)
multiset (const _Compare &__comp, const allocator_type &__a=allocator_type())
multiset ()
multiset< _Key, _Compare, _Alloc > & operator= (const multiset< _Key, _Compare, _Alloc > &__x)
reverse_iterator rbegin () const
reverse_iterator rend () const
size_type size () const
void swap (multiset< _Key, _Compare, _Alloc > &__x)
value_compare value_comp () const

const_iterator find (const key_type &__x) const
iterator find (const key_type &__x)

const_iterator lower_bound (const key_type &__x) const
iterator lower_bound (const key_type &__x)

const_iterator upper_bound (const key_type &__x) const
iterator upper_bound (const key_type &__x)

Constructor & Destructor Documentation

  multiset () [inline]

Default constructor creates no elements.

Definition at line 151 of file stl_multiset.h.

  multiset (_InputIterator __first, _InputIterator __last) [inline]

Builds a multiset from a range.

Parameters:
    first An input iterator.
    last An input iterator.

Create a multiset consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 169 of file stl_multiset.h.

  multiset (_InputIterator __first, _InputIterator __last, const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline]

Builds a multiset from a range.

Parameters:
    first An input iterator.
    last An input iterator.
    comp A comparison functor.
    a An allocator object.

Create a multiset consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 185 of file stl_multiset.h.

  multiset (const multiset< _Key, _Compare, _Alloc > & __x) [inline]

Multiset copy constructor.

Parameters:
    x A multiset of identical element and allocator types.

The newly-created multiset uses a copy of the allocation object used by x.

Definition at line 198 of file stl_multiset.h.

Member Function Documentation

  iterator begin () const [inline]

Returns a read/write iterator that points to the first element in the multiset. Iteration is done in ascending order according to the keys.

Definition at line 236 of file stl_multiset.h.

  void clear () [inline]

Erases all elements in a multiset. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 400 of file stl_multiset.h.

  size_type count (const key_type & __x) const [inline]

Finds the number of elements with given key.

Parameters:
    x Key of elements to be located.

Returns:
    Number of elements with specified key.

Definition at line 411 of file stl_multiset.h.

  bool empty () const [inline]

Returns true if the set is empty.

Definition at line 268 of file stl_multiset.h.

  iterator end () const [inline]

Returns a read/write iterator that points one past the last element in the multiset. Iteration is done in ascending order according to the keys.

Definition at line 245 of file stl_multiset.h.

  std::pair<iterator, iterator> equal_range (const key_type & __x) [inline]

Finds a subsequence matching given key.

Parameters:
    x Key to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

    std::make_pair(c.lower_bound(val),
                   c.upper_bound(val))

 (but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 491 of file stl_multiset.h.

  void erase (iterator __first, iterator __last) [inline]

Erases a [first,last) range of elements from a multiset.

Parameters:
    first Iterator pointing to the start of the range to be erased.
    last Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a multiset. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 390 of file stl_multiset.h.

  size_type erase (const key_type & __x) [inline]

Erases elements according to the provided key.

Parameters:
    x Key of element to be erased.

Returns:
    The number of elements erased.

This function erases all elements located by the given key from a multiset. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 375 of file stl_multiset.h.

  void erase (iterator __position) [inline]

Erases an element from a multiset.

Parameters:
    position An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a multiset. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 360 of file stl_multiset.h.

  iterator find (const key_type & __x) [inline]

Tries to locate an element in a set.

Parameters:
    x Element to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 429 of file stl_multiset.h.

  allocator_type get_allocator () const [inline]

Returns the memory allocation object.

Definition at line 227 of file stl_multiset.h.

  void insert (_InputIterator __first, _InputIterator __last) [inline]

A template function that attemps to insert a range of elements.

Parameters:
    first Iterator pointing to the start of the range to be inserted.
    last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 346 of file stl_multiset.h.

  iterator insert (iterator __position, const value_type & __x) [inline]

Inserts an element into the multiset.

Parameters:
    position An iterator that serves as a hint as to where the element should be inserted.
    x Element to be inserted.

Returns:
    An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on 'hinting'.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 333 of file stl_multiset.h.

  iterator insert (const value_type & __x) [inline]

Inserts an element into the multiset.

Parameters:
    x Element to be inserted.

Returns:
    An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Insertion requires logarithmic time.

Definition at line 309 of file stl_multiset.h.

  key_compare key_comp () const [inline]

Returns the comparison object.

Definition at line 219 of file stl_multiset.h.

References _Rb_tree::key_comp().

  iterator lower_bound (const key_type & __x) [inline]

Finds the beginning of a subsequence matching given key.

Parameters:
    x Key to be located.

Returns:
    Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 450 of file stl_multiset.h.

  size_type max_size () const [inline]

Returns the maximum size of the set.

Definition at line 278 of file stl_multiset.h.

  multiset<_Key,_Compare,_Alloc>& operator= (const multiset< _Key, _Compare, _Alloc > & __x) [inline]

Multiset assignment operator.

Parameters:
    x A multiset of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 209 of file stl_multiset.h.

References multiset::_M_t.

  reverse_iterator rbegin () const [inline]

Returns a read/write reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys.

Definition at line 254 of file stl_multiset.h.

  reverse_iterator rend () const [inline]

Returns a read/write reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys.

Definition at line 263 of file stl_multiset.h.

  size_type size () const [inline]

Returns the size of the set.

Definition at line 273 of file stl_multiset.h.

  void swap (multiset< _Key, _Compare, _Alloc > & __x) [inline]

Swaps data with another multiset.

Parameters:
    x A multiset of the same element and allocator types.

This exchanges the elements between two multisets in constant time. (It is only swapping a pointer, an integer, and an instance of the Compare type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 293 of file stl_multiset.h.

References multiset::_M_t.

Referenced by std::swap().

  iterator upper_bound (const key_type & __x) [inline]

Finds the end of a subsequence matching given key.

Parameters:
    x Key to be located.

Returns:
    Iterator pointing to the first element greater than key, or end().

Definition at line 466 of file stl_multiset.h.

  value_compare value_comp () const [inline]

Returns the comparison object.

Definition at line 223 of file stl_multiset.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.